

#include "queue.h"


void  qInit( queue *q )
{
   q->head = q->tail = 0;
   q->nelem=0;
}



void qInsertHead(queue* list,qnode* node)
{
	node->next=list->head;
	list->head=node; 								\
	if(!list->tail) list->tail=node;
	list->nelem++;
}



void qInsertTail(queue* list,qnode* node)
{
	node->next=0;									
	if (list->head) list->tail->next=node;  					
	else 				 list->head=node; 						 	
	list->tail=node;
	list->nelem++;
}


void qInsertAfter(queue* list,qnode* anode,qnode* node)
{
	node->next=anode->next; 						
	anode->next=node; 								   
	if (!node->next) list->tail=node;        
	list->nelem++;
}


qnode*	qRemoveHead(queue* list)
{
	qnode* e = list->head;
	if (e) {
		list->head=list->head->next; 
		if (!list->head) list->tail=0;
		list->nelem--;
	}
	return e;
}


qnode* 	qRemoveAfter(queue* list,qnode* anode)
{
	qnode* e = anode->next;

	if (e) {
		anode->next=anode->next->next; 				 
		if(!anode->next) list->tail=anode;        
		list->nelem--;
	}
	return e;
}


qnode*	qSelRemove(queue* list,qnode* node)
{
	qnode* prev;
	qnode* cur;

	//this is only a single chained list so we will have to
	//wind through the list until the node is found (or not!):
	prev=0;
	for (cur=list->head;cur;cur=cur->next) {
		if (cur==node) {
			if (prev) {
				prev->next = cur->next;
				if (!prev->next) list->tail=prev;
			} else {
				list->head = cur->next;
				if (!list->head) list->tail=0;
			}
			list->nelem--;
			return cur;
		}
		prev=cur;
	}
	return 0;
}



void					qPurge(queue* q)
{
	while (qRemoveHead(q)) /**/;
}

		

